import discord

from ui_tests_shared.command_selectors_enum import CommandSelectorsEnum
from ui_tests_shared.command_test_case_with_app import CommandTestCaseWithApp
from ui_tests_shared.decorators import Async


class PingCommandTestCase(CommandTestCaseWithApp):

    @Async.async_func
    async def test_ping(self):
        correct_response = self._t.transform('modules.base.pong')
        self.assertIsNotNone(correct_response)
        self.send_command('ping', CommandSelectorsEnum.ping)

        def check(m: discord.Message):
            return m.author.id == self._test_settings.bot_id

        response = await self._bot.wait_for('message', check=check, timeout=10)
        self.assertEqual(response.content, correct_response)
